'' PropCOMM VT100_VGA V2.0b Original By Jeff Ledger
'' VT100 Terminal
'' adaptetd for AVR CP/M , Joe. G. 2013
'' V0.1

CON

   _clkmode  = xtal1 + pll16x
   _xinfreq  = 5_000_000               ' 5 MHz Quarz AVR CP/M

   debugvideo= 12    ''DEBUG VIDEO SENT TO TV -- SHOULD NOT HURT ANYTHING

   keyboard  = 26                      ' Keyboard input
   video     = 16                      ' Video output

   serXmit   = 30                      ' Serial Transmit
   serRecv   = 31                      ' Serial Receive

   baud      = 9600                   ' Default AVR CP/M is 115200

  BLACK             = $02
  GREY              = $03
  LWHITE            = $06
  BWHITE            = $07
  LMAGENTA          = $A3
  WHITE             = $AF
  RED               = $A2
  LRED              = $1A
  LPURPLE           = $1B
  PURPLE            = $03
  LGREEN            = $1C
  SKYBLUE           = $1D
  YELLOW            = $1E
  BYELLOW           = $A6
  LGREY             = $1F
  DGREY             = $08
  GREEN             = $A4
  ORANGE            = $06
  BLUE              = $A1
  CYAN              = $1C
  MAGENTA           = $FC
  LYELLOW           = $1E

  CR                = $0D
  LF                = $0A
  TAB               = $09
  BKS               = $08

  bspKey            = $C8
  escape            = $CB
  backspace         = 8
  fReturn           = 13
  fLinefeed         = 10
  fEof              = -1



OBJ

  debug  : "aigeneric_driver"
  text   : "VGA_1024"
  key    : "comboKeyboard"             ' Keyboard Driver
  ser    : "FullDuplexSerial"          ' Full Duplex Serial Controller


PUB start | i, a, b, TimeCnt

  debug.start(debugvideo)
  debug.str(string("DEBUG READY",13,13))

  key.start(keyboard)                           ' Start keyboard driver
  text.start(video)                             ' Start terminal screen
  ser.start(serRecv,serXmit,%0000,baud)         ' Start V24 to AVR CP/M

  titlescreen                                   ' Print Startmessage
  terminal                                      ' Terminal Programm

PRI terminal | local,remote,duplex,vt100,byte2,byte3,byte1,byte4,byte5,byte6,byte7,loop,var1,col,row

   vt100 := 0
   duplex := 0
   repeat
      local := key.key
      if local > 0

         if local > 608         '' Assume CTRL key is being held
            local:=local-608    '' Redefine as CTRL+char

         if local == 208
            local := 0
            titlescreen

         ser.tx(local)

         if local == bspKey
           ser.tx(8)
             if duplex == 1  'Display Backspace in Half Duplex mode
                 text.str(string(backspace," ",backspace,backspace))

      '## Deal with remote data if present ##

      remote := ser.rxtime(100)

      if remote == 15
         remote:=0

      if remote > 10        '' Used for debugging.  Can be removed.
       debug.out(remote)    '' Display everthing on the TV terminal


      if remote == 27 'vt100 ESC code is being sent
         vt100:=1
         byte1:=0
         byte2:=0
         byte3:=0
         byte4:=0
         byte5:=0
         byte6:=0
         byte7:=0
         remote:=0 'Don't display the ESC code

      if remote == 91 and vt100 == 1 'look for open bracket [
         vt100:=2 'start recording code


      if vt100==2


         if remote > 10
           byte7:=byte6
           byte6:=byte5 ''    My Mini Buffer
           byte5:=byte4
           byte4:=byte3
           byte3:=byte2 ''Record the last 7 bytes
           byte2:=byte1
           byte1:=remote

         '' Remove some unsupported codes from being shown.

         if remote == 109 'look for lowercase m
            vt100:=0

         if remote == 104 'look for lowercase h
            vt100:=0

         if remote == 61  'lool for =
            vt100:=0

         if remote == 114 'look for lowercase r
            vt100:=0

         if remote == 108 'look for lowercase l
            vt100:=0

         if remote == 62  'look for >
            vt100:=0

         if remote == 72 or remote == 102'' HOME CURSOR (uppercase H or lowercase f)
            if byte2==91 or byte2==59   ''look for [H or ;f
               text.home

            '' Check for X & Y with [H or ;f   -   Esc[Line;ColumnH

            else
              if byte4 == 59 '' Assume that col is greater than 9
                byte3:=byte3-48    'Grab 10's
                byte2:=byte2-48    'Grab 1's
                byte3:=byte3*10    'Multiply 10's
                byte3:=byte3+byte2 'Add 1's
                col:=byte3         'Set cols

                if byte7 == 91''Assume row number is greater than 9
                   byte6:=byte6-48 'Grab 10's
                   byte5:=byte5-48 'Grab 1's
                   byte6:=byte6*10 'Multiply 10's
                   byte6:=byte6+byte5 'Add 1's
                   row:=byte6

                if byte6 == 91'Assume row number is less than 10
                   byte5:=byte5-48 'Grab 1's
                   row:=byte5

              if byte3 == 59 '' Assume that col is less an 10
                byte2:=byte2-48    'Grab 1's
                col:=byte2         'set cols

                if byte6 == 91''Assume row number is greater than 9
                   byte5:=byte5-48 'Grab 10's
                   byte4:=byte4-48 'Grab 1's
                   byte5:=byte5*10 'Multiply 10's
                   byte5:=byte5+byte4 'Add 1's
                   row:=byte5
                if byte5 == 91 'Assume that col is greater than 10
                   byte4:=byte4-48 'Grab 1's
                   row:=byte4

              text.cursloc(col,row)



            vt100:=0

         if remote == 74    '' CLEAR SCREEN
            if byte2==91    '' look for [J
               text.cls
            vt100:=0

         if remote == 66    '' CURSOR DOWN    Esc[ValueB
            if byte4 == 91 '' Assume number over 10
              byte3:=byte3-48
              byte2:=byte2-48
              byte3:=byte3*10
              byte3:=byte3+byte2
              var1:=byte3
            if byte3 == 91 '' Assume number is less 10
              byte2:=byte2-48
              var1:=byte2

              var1:=var1-1 '' Seems to move too far with B2 ''May remove
              debug.color(yellow)
              debug.dec(var1)
              debug.color(white)


            loop:=0
            repeat until loop == var1
               loop++
               text.out($C3)

            vt100:=0


         if remote == 65    '' CURSOR UP   Esc[ValueA
            if byte4 == 91 '' Assume number over 10
              byte3:=byte3-48
              byte2:=byte2-48
              byte3:=byte3*10
              byte3:=byte3+byte2
              var1:=byte3
            if byte3 == 91 '' Assume number is less 10
              byte2:=byte2-48
              var1:=byte2

            loop:=0
            repeat until loop == var1
               text.out($C2)
               loop++
            vt100:=0

         remote:=0 '' hide all codes from the VGA output.

      if remote == 8
         text.str(string(backspace," ",backspace))
         remote := 0



      if remote > 11
           text.out(remote)

PUB titlescreen

  text.cls
  text.color($24) 'text.color($76)
  text.str(string(13,"AVR CP/M VT100 Terminal V0.1",13))
  text.str(string("Terminal Ready",13))